=== src/tests/CMakeLists.txt ===
add_test_files(
    alternating_iterator.cpp
    bitmath_func.cpp
    enum_over_optimisation.cpp
    flatset_type.cpp
    history_func.cpp
    landscape_partial_pixel_z.cpp
    math_func.cpp
    mock_environment.h
    mock_fontcache.h
    mock_spritecache.cpp
    mock_spritecache.h
    string_builder.cpp
    string_consumer.cpp
    string_inplace.cpp
    string_func.cpp
    test_main.cpp
    test_network_crypto.cpp
    test_script_admin.cpp
    test_window_desc.cpp
    tilearea.cpp
    utf8.cpp
)
