=== src/widgets/CMakeLists.txt ===
add_files(
    ai_widget.h
    airport_widget.h
    autoreplace_widget.h
    bootstrap_widget.h
    bridge_widget.h
    build_vehicle_widget.h
    cheat_widget.h
    company_widget.h
    console_widget.h
    date_widget.h
    depot_widget.h
    dock_widget.h
    dropdown_widget.h
    engine_widget.h
    error_widget.h
    fios_widget.h
    framerate_widget.h
    game_widget.h
    genworld_widget.h
    goal_widget.h
    graph_widget.h
    group_widget.h
    help_widget.h
    highscore_widget.h
    industry_widget.h
    intro_widget.h
    league_widget.h
    link_graph_legend_widget.h
    main_widget.h
    misc_widget.h
    music_widget.h
    network_chat_widget.h
    network_content_widget.h
    network_widget.h
    newgrf_debug_widget.h
    newgrf_widget.h
    news_widget.h
    object_widget.h
    order_widget.h
    osk_widget.h
    picker_widget.h
    rail_widget.h
    road_widget.h
    screenshot_widget.h
    script_widget.h
    settings_widget.h
    sign_widget.h
    smallmap_widget.h
    station_widget.h
    statusbar_widget.h
    story_widget.h
    subsidy_widget.h
    terraform_widget.h
    timetable_widget.h
    toolbar_widget.h
    town_widget.h
    transparency_widget.h
    tree_widget.h
    vehicle_widget.h
    viewport_widget.h
    waypoint_widget.h
)
