=== src/3rdparty/icu/tests/CMakeLists.txt ===
add_test_files(
    test_srtest.cpp
    CONDITION ICU_i18n_FOUND
)
