=== debian/changelog ===
openttd (15.1-1) unstable; urgency=medium

  * [fc421ac] New upstream release 15.1
  * [23d0c89] Bump standards version to 4.7.3
  * [4ef26cf] Remove gcc 15 build fix patch, which is included upstream
  * [0cc814a] Fix cross-building for arm64. Thanks to Helmut Grohne for
    the patch (Closes: #1121782)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Wed, 18 Feb 2026 14:59:58 +0100
